
SET SQL_MODE="NO_AUTO_VALUE_ON_ZERO";
SET time_zone = "+00:00";

-- Database: `cjcs_web`
--

-- --------------------------------------------------------

--
-- Table structure for table `prt_reports`
--

CREATE TABLE IF NOT EXISTS `prt_reports` (
  `prt_report_id` int(11) NOT NULL AUTO_INCREMENT,
  `file_name` varchar(255) NOT NULL,
  `file_address` varchar(255) DEFAULT NULL,
  `uploader_name` varchar(255) DEFAULT NULL,
  `problem_type` varchar(255) DEFAULT NULL,
  `crash` bit(1) DEFAULT b'0',
  `uploader_comment` varchar(5000) DEFAULT NULL,
  `admin_comment` varchar(5000) DEFAULT NULL,
  `jabber_version` int(10) DEFAULT '0',
  `is_resolved` tinyint(1) NOT NULL DEFAULT '0',
  `date` timestamp NULL DEFAULT CURRENT_TIMESTAMP,
  PRIMARY KEY (`prt_report_id`)
) ENGINE=MyISAM  DEFAULT CHARSET=latin1 AUTO_INCREMENT=1 ;

--
-- Table structure for table `configuration`
--

CREATE TABLE IF NOT EXISTS `configuration` (
  `key_name` varchar(255) NOT NULL,
  `value` varchar(255) NOT NULL,
  `description` varchar(255) NOT NULL,
  PRIMARY KEY (`key_name`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

--
-- Dumping data for table `configuration`
--

INSERT INTO `configuration` (`key_name`, `value`, `description`) VALUES
('MAINTENENCE_MODE', '', 'toggle when backend scripts are running, so we can notify the caller we''re busy'),
('QUERY_CACHE_DIR', '/media/disk2/web/cjcs/querycache', 'location of query cache files'),
('QUERY_CACHE_DURATION', '86400', 'duration to keep a query around, in seconds'),