<?php
require_once './dbConn.php';

function rename_file($file)
{
	$fileNameArray = explode(".", $file);
	$timeStamp =  date("d-m-Y_H-i-s", time());
	$fileNameNew = $fileNameArray[0] . "_" . $timeStamp . ".zip";
		
	$text = "Zip file renamed from " . $file . " to " . $fileNameNew;
	error_log($text);
		
	return $fileNameNew;
}
function find_username($file)
{
  if (!isset($file))
  {
    return "unknown";
  }
  $posStart = strripos($file,")-")+2;
  $posEnd = strripos($file,".zip");
  return substr($file,$posStart,($posEnd-$posStart));
}
$fileidx = "zipFileName";
if (!isset($_FILES[$fileidx]))
{
  error_log('Unknown filetype, expecting "'.$fileidx.'"');
  //TODO: return 500 error
}
if ($_FILES[$fileidx]['type'] != "application/zip" && $_FILES[$fileidx]['type'] != "application/octet-stream")
{
  error_log("Unknown mime type:[".$_FILES[$fileidx]['type']."]");
  //TODO: return 500 error
}
if (empty($_FILES[$fileidx]["tmp_name"]))
{
  error_log("Filesize:[".$_FILES[$fileidx]['size']."] exceeds server limit!");
  //TODO: return 500 error
}
if (!empty($_FILES[$fileidx]["error"]))
{
  error_log("Error:[".$_FILES[$fileidx]['error']."] in POST method uploads");
  //TODO: return 500 error
}
	
error_log("Upload function called");
error_log("Temp Location: [".$_FILES[$fileidx]["tmp_name"]."]");

$uploader_name = "";
$problem_type = "";
$isCrash = 0;
$comment = "";
$pieces = "";
$time = date("Y-m-d H:i:s", time());  	
$fileNameNew = rename_file($_FILES[$fileidx]["name"]);
$target = "../uploads/" . $fileNameNew;
$fileAddress = "uploads/" . $fileNameNew;
	
move_uploaded_file($_FILES[$fileidx]["tmp_name"], $target);

// open file
$zip = zip_open($target);
if (is_resource($zip))
{
	error_log("Zip file opened");
	  
	while (($zip_entry = zip_read($zip)))
	{
		if (zip_entry_name($zip_entry) == 'metadata.txt')
		{
			error_log("metadata.txt file found");
			if (zip_entry_open($zip, $zip_entry))
            {
				error_log("metadata.txt file opened");
				// read the contents of the .txt file to a string
				$contents = zip_entry_read($zip_entry);
				$contents = substr(str_replace("\0",'',$contents),2);
				zip_entry_close($zip_entry);
            }
	      
			// explode the string into an array at each comma
			$pieces = explode(",", $contents);
		  
			if ($pieces[1] == "")
			{
				error_log("No meaningful content found in metadata.txt file");
			}
			else
			{
				$text = "PRT submitted by: "  . $pieces[0];
				error_log("$text");
				$text = "PRT problem: "  . $pieces[1];
				error_log("$text");
			}
		
		} // end of processing metadata.txt

        $comment_file = "";
        if (zip_entry_name($zip_entry) == 'user-comment.txt')
	    {
			error_log("user-comment.txt file found");
			if (zip_entry_open($zip, $zip_entry))
            {
				error_log("user-comment.txt file opened");
				// read the contents of the .txt file to a string
				$comment = zip_entry_read($zip_entry);
				zip_entry_close($zip_entry);
			
				$comment = substr(str_replace("\0",'',$comment),2);
				$comment = htmlspecialchars($comment);
				// utf8_encode is necessary to ensure XML doesn't break later on
				$comment = utf8_encode ($comment);
            }
     	}
	    // MAC PRT uses UserComments.txt instead
     	elseif (zip_entry_name($zip_entry) == 'UserComments.txt')
     	{			
           	error_log("UserComments.txt file found");
			if (zip_entry_open($zip, $zip_entry))
            {
				error_log("UserComments.txt file opened");
				// read the contents of the .txt file to a string
				$comment = zip_entry_read($zip_entry);
				zip_entry_close($zip_entry);
			
				$comment = substr(str_replace("\0",'',$comment),2);
				$comment = htmlspecialchars($comment);
				// utf8_encode is necessary to ensure XML doesn't break later on
				$comment = utf8_encode ($comment);
            }
     	}
	} // end of processing files within the PRT ZIP	
    // close .zip file
    zip_close($zip);
     
	// Replace special characters found in comment text
	$comment = mysql_real_escape_string($comment,$conn->db_conn);
    $uploader_name = (isset($pieces[0])) ? $pieces[0] : find_username($_FILES[$fileidx]['name']);
    $problem_type = (isset($pieces[1])) ? $pieces[1] : "";
    $isCrash = (isset($pieces[2]) && $pieces[2] == '1') ? 1 : 0;
    $jabberVersion = (isset($pieces[3])) ? $pieces[3] : 0;

	$query = "INSERT INTO `prt_reports` (`uploader_name`, `problem_type`, `crash`, `file_name`, `uploader_comment`, `date`, `file_address`, `jabber_version`) VALUES('$uploader_name', '$problem_type', $isCrash, '$fileNameNew', '$comment' , '$time', '$fileAddress', '$jabberVersion')";
	error_log($query);	
    if ($conn->query($query))
	{
		error_log("Metadata added to db");
	}
	else 
	{
		error_log("Unable to add metadata to db");
	}	
}
// if file doesn't open, delete it
else
{
	error_log("Unable to open zip file");
	$file = "../uploads/" . $_FILES[$fileidx]["name"];
	if (is_file($file))
	{
      ulink($file);
	}
 	//TODO: provide notification that the upload failed!
}
?>